package com.zhongzheng.modules.base.service.impl;

import cn.hutool.core.bean.BeanUtil;
import cn.hutool.core.util.StrUtil;
import com.zhongzheng.common.utils.DateUtils;
import com.zhongzheng.modules.base.bo.ProfileTpBusinessAddBo;
import com.zhongzheng.modules.base.bo.ProfileTpBusinessEditBo;
import com.zhongzheng.modules.base.bo.ProfileTpBusinessQueryBo;
import com.zhongzheng.modules.base.domain.ProfileTpBusiness;
import com.zhongzheng.modules.base.mapper.ProfileTpBusinessMapper;
import com.zhongzheng.modules.base.service.IProfileTpBusinessService;
import com.zhongzheng.modules.base.vo.ProfileTpBusinessVo;
import org.springframework.stereotype.Service;
import com.baomidou.mybatisplus.extension.service.impl.ServiceImpl;
import com.baomidou.mybatisplus.core.conditions.query.LambdaQueryWrapper;
import com.baomidou.mybatisplus.core.toolkit.Wrappers;
import com.github.pagehelper.Page;

import java.util.Collection;
import java.util.Collections;
import java.util.List;
import java.util.stream.Collectors;

/**
 * 资料模板业务层次Service业务层处理
 *
 * @author hjl
 * @date 2021-11-19
 */
@Service
public class ProfileTpBusinessServiceImpl extends ServiceImpl<ProfileTpBusinessMapper, ProfileTpBusiness> implements IProfileTpBusinessService {

    @Override
    public ProfileTpBusinessVo queryById(Long id){
        ProfileTpBusiness db = this.baseMapper.selectById(id);
        return BeanUtil.toBean(db, ProfileTpBusinessVo.class);
    }

    @Override
    public List<ProfileTpBusinessVo> queryList(ProfileTpBusinessQueryBo bo) {
        LambdaQueryWrapper<ProfileTpBusiness> lqw = Wrappers.lambdaQuery();
        lqw.eq(bo.getProfileTpId() != null, ProfileTpBusiness::getProfileTpId, bo.getProfileTpId());
        lqw.eq(bo.getEducationTypeId() != null, ProfileTpBusiness::getEducationTypeId, bo.getEducationTypeId());
        lqw.eq(bo.getBusinessId() != null, ProfileTpBusiness::getBusinessId, bo.getBusinessId());
        lqw.eq(bo.getProjectId() != null, ProfileTpBusiness::getProjectId, bo.getProjectId());
        return entity2Vo(this.list(lqw));
    }

    /**
    * 实体类转化成视图对象
    *
    * @param collection 实体类集合
    * @return
    */
    private List<ProfileTpBusinessVo> entity2Vo(Collection<ProfileTpBusiness> collection) {
        List<ProfileTpBusinessVo> voList = collection.stream()
                .map(any -> BeanUtil.toBean(any, ProfileTpBusinessVo.class))
                .collect(Collectors.toList());
        if (collection instanceof Page) {
            Page<ProfileTpBusiness> page = (Page<ProfileTpBusiness>)collection;
            Page<ProfileTpBusinessVo> pageVo = new Page<>();
            BeanUtil.copyProperties(page,pageVo);
            pageVo.addAll(voList);
            voList = pageVo;
        }
        return voList;
    }

    @Override
    public Boolean insertByAddBo(ProfileTpBusinessAddBo bo) {
        ProfileTpBusiness add = BeanUtil.toBean(bo, ProfileTpBusiness.class);
        validEntityBeforeSave(add);
        return this.save(add);
    }

    @Override
    public Boolean updateByEditBo(ProfileTpBusinessEditBo bo) {
        ProfileTpBusiness update = BeanUtil.toBean(bo, ProfileTpBusiness.class);
        validEntityBeforeSave(update);
        return this.updateById(update);
    }

    /**
     * 保存前的数据校验
     *
     * @param entity 实体类数据
     */
    private void validEntityBeforeSave(ProfileTpBusiness entity){
        //TODO 做一些数据校验,如唯一约束
    }

    @Override
    public Boolean deleteWithValidByIds(Collection<Long> ids, Boolean isValid) {
        if(isValid){
            //TODO 做一些业务上的校验,判断是否需要校验
        }
        return this.removeByIds(ids);
    }
}
